# CodingToolBox

## github:
[CodingToolBox](https://github.com/kent010341/CodingToolBox)

## Requires:
* Python 3.6 (or above)
* numpy
* matplotlib

## Update dialog
* 1.0.0: Upload package.
* 1.1.0: Add two methods: ask_file_popup, ask_folder_popup
* 1.2.0: Add method: install_checker
  * 1.2.1: Edit copy in var_form.
  * 1.2.2: Fix init bug.
  * 1.2.3: Fix bug at DetailRecorder.
  * 1.2.4: Fix bug at DetailRecorder.

## Lib Description
* Most of the functions are elaborated at my another repository [useful_coding_tools](https://github.com/kent010341/useful_coding_tools). 
* You can run the file directly to see the demo output. There're also some demo at [CodingToolBox](https://github.com/kent010341/CodingToolBox).

### Class
* AnimatedPlot: Animated showing plot or scatter.
* DetailRecorder: Convenient recording tool.
* ErrorCal: Regression loss calculating tool.

### Methods
* cal_mae: Calculating mean absulate error.
* cal_mape: Calculating mean absolute percentage error.
* cal_mse: Calculating mean square error.
* cal_rmse: Calculating root mean square error.
* get_peak: Get indices and values of peaks of periodical signal by **automatic multiscale-based peak detection (AMPD)** algorithm.
* var_form: Return pure variable form that can easily be used in another script. Set parameter 'copy' as True to copy to scrapbook by using module 'pyperclip'.
* MA_smoothing: Smooth input data by using moving average.
* ask_file_popup: Popup menu for asking file location.
* ask_folder_popup: Popup menu for asking folder location.
* install_checker: Use list as parameter to automatically check if all packages are installed.